/*
*
* Gtk+1.2-Gtk+2.2  Utility routines
* Copyright (C) 2002-2003 by Tito Ragusa <tito-wolit@tiscali.it>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of
* the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* Please read the COPYING and README file!!!
*
* Report bugs to <tito-wolit@tiscali.it>
*
*/

/*######################### Start of dialog_window Widget ##########################################################*/
/* gtk-2.0 :ok */
void dialog_ok_callback(GtkWidget *widget,  int *ptr_dialog_retval)
{
	DBG_FUNCTION_NAME;
	exit_if_null(widget);

	SET2(*ptr_dialog_retval,0);
	gtk_main_quit();
}

void dialog_no_callback(GtkWidget *widget,  int *ptr_dialog_retval )
{
	DBG_FUNCTION_NAME;
	exit_if_null(widget);

	SET2(*ptr_dialog_retval,1);
	gtk_main_quit();
}

void dialog_third_callback(GtkWidget *widget, int *ptr_dialog_retval )
{
	DBG_FUNCTION_NAME;
	exit_if_null(widget);

	SET2(*ptr_dialog_retval,2);
	gtk_main_quit();
}

void dialog_check_callback(GtkWidget *widget, int *ptr_check_retval )
{
	DBG_FUNCTION_NAME;
	exit_if_null(widget);

	if(*ptr_check_retval==0)
		SET2(*ptr_check_retval,3);
	else
		SET2(*ptr_check_retval,0);
}

/* gtk-2.0 :ok */

/*
 Returns int=0 for ok/yes
         int=1 for no
		 int=2 for third button/help
		 int=3 for ok (with checkbutton ACTIVE )
		 int=4 for no (with checkbutton ACTIVE )
*/

int dialog_window(const char *title, char *labeltext , int type, int modal_flag, char *third_button_label)
{
	/*
	#define	ONE_BUTTON				((int) 1)
	#define	ONE_BUTTON_ONE_CHECK	((int) 2)
	#define	TWO_BUTTONS				((int) 3)
	#define	TWO_BUTTONS_ONE_CHECK	((int) 4)
	#define	THREE_BUTTONS			((int) 5)
	*/

	GtkWidget *dialog, *button, *label, *table, *frame, *bbox, *checkbutton;
	int dialog_retval=0;
	int *ptr_dialog_retval;
	int check_retval=0;
	int *ptr_check_retval;


	DBG_FUNCTION_NAME;

	ptr_dialog_retval=&dialog_retval;
	ptr_check_retval=&check_retval;

	dialog = window_create	(380, 180, 2,(title==NULL) ? STR_DIALOG_WINDOW : title, GTK_SIGNAL_FUNC(do_nothing), NULL, modal_flag);
	gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
	table = table_create( 6, 6, dialog, 0, NOT_HOMOGENEUS);

	frame = frame_create_on_table( NULL, table, 0, 6, 0, 5);


	label = label_create_on_table(labeltext, table, 0, 6, 0, 5);
	#ifdef USE_GTK_2_0
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
	gtk_misc_set_padding (GTK_MISC(label),8,8);
	#endif

	/*#ifdef DEBUG
	err_msg(labeltext);
	#endfi*/

	bbox = default_button_box_create_on_table( HORIZONTAL, table, 0, 6, 5, 6);

	/* ONE_BUTTON */
	button = button_create_in_container((type==ONE_BUTTON || type==ONE_BUTTON_ONE_CHECK)? STR_OK : STR_YES,
										GTK_SIGNAL_FUNC(dialog_ok_callback), ptr_dialog_retval , bbox);


	if(type==TWO_BUTTONS || type==TWO_BUTTONS_ONE_CHECK || type==THREE_BUTTONS)
	{
		button = button_create_in_container( STR_NO ,GTK_SIGNAL_FUNC(dialog_no_callback), ptr_dialog_retval, bbox);
	}

	if(type==THREE_BUTTONS && !(type==ONE_BUTTON_ONE_CHECK || type==TWO_BUTTONS_ONE_CHECK))
	{
		if(third_button_label==NULL)
			third_button_label= STR_HELP;
		button = button_create_in_container(third_button_label,GTK_SIGNAL_FUNC(dialog_third_callback), ptr_dialog_retval, bbox);
	}

	if (type==ONE_BUTTON_ONE_CHECK || type==TWO_BUTTONS_ONE_CHECK)
	{
		#ifdef DEBUG
		if(third_button_label==NULL) err_msg("%s(): No label for checkbox",__FUNCTION__);
		#endif
		checkbutton=check_create_on_table(third_button_label, GTK_SIGNAL_FUNC(dialog_check_callback), ptr_check_retval, INACTIVE,
									 		table, 0,2,5,6);
	}

	gtk_widget_show_all(dialog);
	gtk_main();
	gtk_widget_destroy(dialog);

	return (dialog_retval+check_retval);
}

/*######################### End of dialod_window Widget   ##########################################################*/
